#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFishingCeleStage.h"
std::auto_ptr<M_ActivityFishingCeleStage> M_ActivityFishingCeleStage::msSingleton(nullptr);

int M_ActivityFishingCeleStage::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleStageData* M_ActivityFishingCeleStage::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFishingCeleStageData>& M_ActivityFishingCeleStage::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleStage::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFishingCeleStage.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleStageData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* ActiveId = element->Attribute("ActiveId");
			std::vector<std::string> vecActiveId;
			boost::split(vecActiveId, ActiveId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecActiveId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecActiveId[i].c_str(), &temp))
				{
					data.mActiveId.push_back(temp);
				}
			}
		}
		{
			const char* ActiveCount = element->Attribute("ActiveCount");
			std::vector<std::string> vecActiveCount;
			boost::split(vecActiveCount, ActiveCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecActiveCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecActiveCount[i].c_str(), &temp))
				{
					data.mActiveCount.push_back(temp);
				}
			}
		}
		data.mSubAllowCount = element->IntAttribute("SubAllowCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFishingCeleStage Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleStage::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFishingCeleStage");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFishingCeleStage");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFishingCeleStageData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "ActiveId", data.mActiveId);
		LuaCfgHelper::readVectorInt(L, "ActiveCount", data.mActiveCount);
		LuaCfgHelper::readInt(L, "SubAllowCount", data.mSubAllowCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFishingCeleStage Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleStage::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFishingCeleStage* M_ActivityFishingCeleStage::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleStage());
	}
	return msSingleton.get();
}

void M_ActivityFishingCeleStage::Release()
{
	msSingleton.reset(nullptr);
}
